/*
This is a part of the LiteStep Shell Source code.

Copyright (C) 1997-2001 The LiteStep Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef __ICONS_H
#define __ICONS_H

#include <windows.h>
#include <windowsx.h>
#include <shlwapi.h>
#include "contextmenu.h"
#include "..\lsapi\lsapi.h"
#include "..\lsapi\lswinbase.h"

struct DESKTOPICON
{
	int x;
	int y;
	RECT iconRect;
	RECT textRect;
	HICON icon;
	char title[MAX_PATH];
	char filename[MAX_PATH];
	DESKTOPICON *next;
};

enum DESKTOPDIRECTION
{
	DD_RIGHT,
	DD_DOWN,
	DD_LEFT,
	DD_UP
};

class Icons
{
public:
	Icons(HWND parentWnd);
	~Icons();

	void show();
	void hide();
	void toggle();

	void paintIcons(HDC hDC);
	void update();
	BOOL mouseEvent(Message& message);

	HANDLE iconChangeHandle;

private:
	HWND _parentWnd;
	BOOL _visible;

	DESKTOPICON *_iconList;
	BOOL _iconsLoaded;

	int _iconX;
	int _iconY;
	int _iconSize;
	int _iconSpacingX;
	int _iconSpacingY;
	char _iconFolder[MAX_PATH];

	BOOL _iconFoldersFirst;
	BOOL _iconHideExtension;
	BOOL _iconShowHidden;

	DESKTOPDIRECTION _iconDirection;
	DESKTOPDIRECTION _iconWrapDirection;
	int _iconWrapCount;

	int _iconTextSpacing;
	int _iconTextHeight;
	int _iconTextWidth;
	HFONT _iconTextFont;
	COLORREF _iconTextColor;
	HBRUSH _iconTextBackground;

	void _loadIcons();
	void _deleteIcons();

	DESKTOPICON *_getIconAtPt(int x, int y);
	DESKTOPICON *_selectedIcon;

	HICON _getIconFromPathEx(LPCSTR pszPath, int cxDesired, int cyDesired);
	int _parseIconLocation(LPSTR szIconFile);

};

#endif//__ICONS_H
